#Summon TeaPlant
execute as @e[type=minecraft:bat,name="Tea Seeds"] run data merge entity @s {Silent:1b,NoAI:1b}
	#on wall
execute as @e[type=minecraft:bat,name="Tea Seeds"] at @s unless block ~ ~ ~ minecraft:farmland run summon minecraft:armor_stand ~ ~-1 ~ {NoGravity:1b,Invisible:1b,PersistenceRequired:1b,Tags:["Tea"]}
execute as @e[type=minecraft:bat,name="Tea Seeds"] at @s unless block ~ ~ ~ minecraft:farmland run setblock ~ ~ ~ minecraft:fern keep
	#on farmland
execute as @e[type=minecraft:bat,name="Tea Seeds"] at @s if block ~ ~ ~ minecraft:farmland run summon minecraft:armor_stand ~ ~-0.93 ~ {NoGravity:1b,Invisible:1b,PersistenceRequired:1b,Tags:["Tea"]}
execute as @e[type=minecraft:bat,name="Tea Seeds"] at @s if block ~ ~ ~ minecraft:farmland run setblock ~ ~1 ~ minecraft:fern keep
	#finishup
execute as @e[type=minecraft:bat,name="Tea Seeds"] at @s run execute as @e[tag=Tea,distance=..1] run scoreboard players add @s growth 1
execute as @e[type=minecraft:bat,name="Tea Seeds"] run tp @s ~ -10 ~
execute as @e[type=minecraft:bat,name="Tea Seeds"] run kill @s
#TeaPlant AI
	#Kill if not 
execute as @e[type=minecraft:armor_stand,tag=Tea] at @s unless block ~ ~ ~ minecraft:farmland run function tea:kill_tea_plant
execute as @e[type=minecraft:armor_stand,tag=Tea] at @s unless block ~ ~1 ~ minecraft:fern unless block ~ ~1 ~ minecraft:large_fern run function tea:kill_tea_plant
		#Plant Count
execute as @e[type=minecraft:armor_stand,tag=Tea] at @s run scoreboard players set @s plantCount 0
execute as @e[type=minecraft:armor_stand,tag=Tea] at @s as @e[type=minecraft:armor_stand,tag=Tea,distance=...1] run scoreboard players add @s plantCount 1
execute as @e[type=minecraft:armor_stand,tag=Tea,scores={plantCount=2..}] at @s if entity @s[scores={growth=1}] run function tea:kill_tea_plant
	#Time
execute as @e[type=minecraft:armor_stand,tag=Tea] if score @s growth <= time growth run scoreboard players add @s growth 1
execute as @e[type=minecraft:armor_stand,tag=Tea] if score @s growth >= time growth run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:oak_leaves",Count:1b,tag:{display:{Name:"{\"text\":\"Tea Leaves\",\"color\":\"dark_purple\",\"bold\":true}"}}}]}
execute as @e[type=minecraft:armor_stand,tag=Tea] if entity @s[nbt={ArmorItems:[{},{},{},{id:"minecraft:oak_leaves",Count:1b,tag:{display:{Name:'{"text":"Tea Leaves","color":"dark_purple","bold":true}'}}}]}] run scoreboard players set @s growth 0
		#Bonemeal
	execute as @e[type=minecraft:armor_stand,tag=Tea] at @s if block ~ ~1 ~ minecraft:large_fern run function tea:fern
	#Replace Tea Leaves
execute as @a if data entity @s {SelectedItem:{id:"minecraft:oak_leaves",Count:1b,tag:{display:{Name:'{"text":"Tea Leaves","color":"dark_purple","bold":true}'}}}} run loot give @s loot tea:tea_plant
execute as @a if data entity @s {SelectedItem:{id:"minecraft:oak_leaves",Count:1b,tag:{display:{Name:'{"text":"Tea Leaves","color":"dark_purple","bold":true}'}}}} run playsound minecraft:entity.item.pickup master @s ~ ~-1 ~ 10 1 1
execute as @a if data entity @s {SelectedItem:{id:"minecraft:oak_leaves",Count:1b,tag:{display:{Name:'{"text":"Tea Leaves","color":"dark_purple","bold":true}'}}}} run clear @s minecraft:oak_leaves{display:{Name:'{"text":"Tea Leaves","color":"dark_purple","bold":true}'}} 1	
#Cauldron ingredients
	#Tea leaf
execute as @e[type=minecraft:item,nbt={Item:{id:"minecraft:kelp",Count:1b,tag:{display:{Name:'{"text":"Tea Leaf","color":"dark_purple","bold":true}'}}}}] at @s if block ~ ~ ~ minecraft:cauldron[level=3] if block ~ ~-1 ~ minecraft:fire unless entity @e[distance=..1,type=minecraft:area_effect_cloud,tag=TeaCauldron] run summon minecraft:area_effect_cloud ~ ~ ~ {Particle:"ambient_entity_effect",NoGravity:1b,Radius:0.5f,RadiusPerTick:0f,Duration:36000,Tags:["TeaCauldron"],Potion:"minecraft:regeneration"}
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,tag=!done] at @s run kill @e[type=minecraft:item,limit=1,distance=..1,nbt={Item:{id:"minecraft:kelp",Count:1b,tag:{display:{Name:'{"text":"Tea Leaf","color":"dark_purple","bold":true}'}}}}]
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,tag=!done] at @s run scoreboard players set @s waterLevel 3
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,tag=!done] at @s run tag @s add done
	#Sugar
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,tag=!sugar] at @s if entity @e[type=minecraft:item,nbt={Item:{id:"minecraft:sugar",Count:1b}},distance=..1] run function tea:sugar
	#Milk
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,tag=!milk] at @s if entity @e[type=minecraft:item,nbt={Item:{id:"minecraft:milk_bucket",Count:1b}},distance=..1] run function tea:milk
	#Kill Tea Cauldron
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron] at @s unless block ~ ~ ~ minecraft:cauldron run kill @s
#Cauldron
	#Potions
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,scores={waterLevel=3}] at @s if block ~ ~ ~ minecraft:cauldron[level=2] run function tea:cauldron
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,scores={waterLevel=2}] at @s if block ~ ~ ~ minecraft:cauldron[level=1] run function tea:cauldron
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,scores={waterLevel=1}] at @s if block ~ ~ ~ minecraft:cauldron[level=0] run function tea:cauldron

	#Water level check and update
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,scores={waterLevel=3}] at @s if block ~ ~ ~ minecraft:cauldron[level=2] run scoreboard players set @s waterLevel 2
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,scores={waterLevel=2}] at @s if block ~ ~ ~ minecraft:cauldron[level=1] run scoreboard players set @s waterLevel 1
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,scores={waterLevel=1}] at @s if block ~ ~ ~ minecraft:cauldron[level=0] run kill @s
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,scores={waterLevel=2}] at @s if block ~ ~ ~ minecraft:cauldron[level=3] run kill @s
execute as @e[type=minecraft:area_effect_cloud,tag=TeaCauldron,scores={waterLevel=1}] at @s if block ~ ~ ~ minecraft:cauldron[level=2] run kill @s

#Book
execute as @a[tag=!TeaBook] run function tea:guide_book
execute as @a[tag=!TeaBook] run tag @s add TeaBook